%global commit 0ed6894c991fdba3fdedb4f4054fca05603df659
# Set bundle 1 to copy needed jars to lib dir to run on a non-Fedora system.
#global bundle 0
%global enable_tests 0

%if %{enable_tests}
%global skip_test ''
%else
%global skip_test -Dmaven.test.skip=true
%endif
%global shortcommit %(c=%{commit}; echo ${c:0:12})

Name:           jasperstarter
Version:        3.2.1
Release:        1%{?dist}
Summary:        opensource CLI and batch compiler for JasperReports

Group:          Applications/Databases
License:        ASL 2.0
URL:            https://bitbucket.org/cenote/%{name}
Source0:        https://bitbucket.org/cenote/%{name}/get/JasperStarter-%{version}.tar.gz#/cenote-%{name}-%{shortcommit}.tar.gz

BuildRequires:  maven-local hsqldb-lib argparse4j
BuildRequires:  apache-poi jasperreports testng
BuildRequires:  jcalendar jboss-servlet-2.5-api
BuildRequires:  mvn(org.apache.maven.plugins:maven-javadoc-plugin)
BuildRequires:  mvn(org.apache.maven.plugins:maven-antrun-plugin)
#
Requires:       java >= 1.7
BuildArch:      noarch

%description
Run any JasperReport that needs a jdbc, csv, xml, json or empty datasource
Use with any database for which a jdbc driver is available
Run reports with subreports
Execute reports that need runtime parameters. Any parameter whose class has a string constructor is accepted. Additionally the following types are supported or have special handlers:

    date, image (see usage), locale

Optionally prompt for report parameters
Print directly to system default or given printer
Optionally show printer dialog to choose printer
Optionally show printpreview
Export to file in the following formats:

    pdf, rtf, xls, xlsMeta, xlsx, docx, odt, ods, pptx, csv, csvMeta, html, xhtml, xml, jrprint

Export multiple formats in one commanding call
Compile, print and export in one commanding call
View, print or export previously filled reports (use jrprint file as input)
Can compile a whole directory of .jrxml files.
Integrate in non Java applications (for example PHP, Python)

%package javadoc
Summary:       Javadoc for %{name}

%description javadoc
This package contains javadoc for %{name}.

%prep
%setup -qn cenote-%{name}-%{shortcommit}
# remove binaries that came with the "source"
#find . -name "*.jar" | xargs rm 
%pom_remove_dep :barcode4j
%pom_remove_dep :barbecue
%pom_remove_dep :jasperreports-fonts
%pom_remove_dep :jasperreports-functions
%pom_change_dep javax.servlet:servlet-api org.jboss.spec.javax.servlet:jboss-servlet-api_2.5_spec:
%pom_remove_plugin :git-commit-id-plugin 
%pom_remove_plugin :launch4j-maven-plugin
%pom_remove_plugin :maven-project-info-reports-plugin
%pom_remove_plugin :maven-site-plugin

cat >jasperstarter.sh <<'EOF'
#!/bin/sh
java -jar "%{_javadir}/%{name}/%{name}.jar" "$@"
EOF

%build
%mvn_build -- %{skip_test}

%install
%mvn_install

# server application runs from /var/lib/jasperstarter
install -m 0755 jasperstarter.sh -D %{buildroot}%{_libexecdir}/%{name}/jasperstarter.sh
mkdir -p %{buildroot}%{_bindir}
ln -sf %{_libexecdir}/%{name}/jasperstarter.sh %{buildroot}%{_bindir}/%{name}

%files -f .mfiles
%license LICENSE
%doc CHANGES README.md NOTICE 
%{_bindir}/jasperstarter
%{_libexecdir}/jasperstarter

%files javadoc -f .mfiles-javadoc
%license LICENSE

%changelog

* Mon Apr 30 2018 Stuart D. Gathman <stuart@gathman.org> 3.2.1-1
- Initial RPM
